package com.cursedcauldron.wildbackport.client.particle;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_3999;
import net.minecraft.class_4002;
import net.minecraft.class_4003;
import net.minecraft.class_638;
import net.minecraft.class_703;
import record;

@Environment(EnvType.CLIENT)
public class SculkChargeParticle extends class_4003 {
    private final class_4002 sprites;

    public SculkChargeParticle(
        class_638 level,
        double x,
        double y,
        double z,
        double xMotion,
        double yMotion,
        double zMotion,
        class_4002 sprites
    ) {
        super(level, x, y, z, xMotion, yMotion, zMotion);
        this.sprites = sprites;
        this.field_28786 = 0.96F;
        this.method_3087(1.5F);
        this.field_3862 = false;
        this.method_18142(sprites);
    }

    @Override
    protected int method_3068(float delta) {
        return 240;
    }

    @Override
    public class_3999 method_18122() {
        return class_3999.field_17829;
    }

    @Override
    public void method_3070() {
        super.method_3070();
        this.method_18142(this.sprites);
    }

    public record Provider(class_4002 sprites)
        implements ParticleProvider<SculkChargeParticleOptions> {
        @Override
        public class_703 createParticle(
            SculkChargeParticleOptions options,
            class_638 level,
            double x,
            double y,
            double z,
            double xMotion,
            double yMotion,
            double zMotion
        ) {
            SculkChargeParticle particle = new SculkChargeParticle(
                level, x, y, z, xMotion, yMotion, zMotion, this.sprites
            );
            particle.method_3083(1.0F);
            particle.method_34753(xMotion, yMotion, zMotion);
            particle.field_3857 = particle.field_3839 = options.roll();
            particle.method_3077(level.method_8409().nextInt(12) + 8);
            return particle;
        }
    }
}