package com.cursedcauldron.wildbackport.client.sound;

import java.util.function.Supplier;
import net.minecraft.class_2498;
import net.minecraft.class_3414;

public class CoreSoundType extends class_2498 {
    private final Supplier<class_3414> breakSound;
    private final Supplier<class_3414> stepSound;
    private final Supplier<class_3414> placeSound;
    private final Supplier<class_3414> hitSound;
    private final Supplier<class_3414> fallSound;

    @SuppressWarnings("all")
    public CoreSoundType(
        Supplier<class_3414> breakSound,
        Supplier<class_3414> stepSound,
        Supplier<class_3414> placeSound,
        Supplier<class_3414> hitSound,
        Supplier<class_3414> fallSound
    ) {
        super(1.0F, 1.0F, null, null, null, null, null);
        this.breakSound = breakSound;
        this.stepSound = stepSound;
        this.placeSound = placeSound;
        this.hitSound = hitSound;
        this.fallSound = fallSound;
    }

    @Override
    public class_3414 method_10595() {
        return this.breakSound.get();
    }

    @Override
    public class_3414 method_10594() {
        return this.stepSound.get();
    }

    @Override
    public class_3414 method_10598() {
        return this.placeSound.get();
    }

    @Override
    public class_3414 method_10596() {
        return this.hitSound.get();
    }

    @Override
    public class_3414 method_10593() {
        return this.fallSound.get();
    }
}