package com.cursedcauldron.wildbackport.common.entities.access;

import java.util.function.BiConsumer;
import javax.annotation.Nullable;
import net.minecraft.class_1297;
import net.minecraft.class_1937;
import net.minecraft.class_5576;
import net.minecraft.class_5714;
import net.minecraft.class_5715;

public class Listener {
    public interface Instance {
        static Instance of(class_5715 instance) {
            return (Instance) instance;
        }

        void onPosCallback(class_1937 level);

        void setListener(class_5714 listener, @Nullable class_1937 level);

        class_5714 getListener();
    }

    public interface MobInstance {
        static MobInstance of(class_1297 entity) {
            return MobInstance.class.cast(entity);
        }

        default void
        updateEventHandler(BiConsumer<class_5715, class_1937> callback) {}
    }

    public interface Callback<T> extends class_5576<T> {
        @SuppressWarnings("unchecked")
        static <T> Callback<T> of(T entity) {
            return (Callback<T>) entity;
        }

        void onSectionChange(T entry);
    }
}