package com.cursedcauldron.wildbackport.common.entities.brain.frog;

import com.cursedcauldron.wildbackport.common.entities.Frog;
import com.cursedcauldron.wildbackport.common.entities.access.api.Poses;
import com.google.common.collect.ImmutableMap;
import net.minecraft.class_3218;
import net.minecraft.class_4050;
import net.minecraft.class_4097;
import net.minecraft.class_4140;
import net.minecraft.class_4141;

public class Croak extends class_4097<Frog> {
    private int ticks;

    public Croak() {
        super(
            ImmutableMap.of(class_4140.field_18445, class_4141.field_18457), 100
        );
    }

    @Override
    protected boolean checkExtraStartConditions(class_3218 level, Frog frog) {
        return frog.isInPose(class_4050.field_18076);
    }

    @Override
    protected boolean canStillUse(class_3218 level, Frog frog, long time) {
        return this.ticks < 40;
    }

    @Override
    protected void start(class_3218 level, Frog frog, long time) {
        if (!frog.method_5816() && !frog.method_5771()) {
            frog.method_18380(Poses.CROAKING.get());
            this.ticks = 0;
        }
    }

    @Override
    protected void stop(class_3218 level, Frog frog, long time) {
        frog.method_18380(class_4050.field_18076);
    }

    @Override
    protected void tick(class_3218 level, Frog frog, long time) {
        ++this.ticks;
    }
}