package com.cursedcauldron.wildbackport.common.entities.brain.frog;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;
import net.minecraft.class_1309;
import net.minecraft.class_4140;
import net.minecraft.class_4148;
import net.minecraft.class_6045;
import com.cursedcauldron.wildbackport.common.entities.Frog;
import com.cursedcauldron.wildbackport.common.registry.entity.WBMemoryModules;

//<>

public class FrogAttackablesSensor extends class_6045 {
    @Override
    protected boolean method_35148(class_1309 entity, class_1309 target) {
        return !entity.method_18868().method_18896(class_4140.field_30246)
            && class_4148.method_36982(entity, target) && Frog.isValidFrogFood(target)
            && !this.cantReachTarget(entity, target) && target.method_24516(entity, 10.0D);
    }

    private boolean cantReachTarget(class_1309 entity, class_1309 target) {
        List<UUID> targets
            = entity.method_18868()
                  .method_18904(WBMemoryModules.UNREACHABLE_TONGUE_TARGETS.get())
                  .orElseGet(ArrayList::new);
        return targets.contains(target.method_5667());
    }

    @Override
    protected class_4140<class_1309> method_35150() {
        return class_4140.field_30243;
    }
}