package com.cursedcauldron.wildbackport.common.entities.brain.warden;

import com.cursedcauldron.wildbackport.client.registry.WBSoundEvents;
import com.cursedcauldron.wildbackport.common.entities.Warden;
import com.cursedcauldron.wildbackport.common.entities.access.api.Poses;
import com.google.common.collect.ImmutableMap;
import net.minecraft.class_1297;
import net.minecraft.class_3218;
import net.minecraft.class_4097;
import net.minecraft.class_4140;
import net.minecraft.class_4141;

//<>

public class Digging<E extends Warden> extends class_4097<E> {
    public Digging(int duration) {
        super(
            ImmutableMap.of(
                class_4140.field_22355,
                class_4141.field_18457,
                class_4140.field_18445,
                class_4141.field_18457
            ),
            duration
        );
    }

    @Override
    protected boolean canStillUse(class_3218 level, E entity, long time) {
        return entity.method_35049() == null;
    }

    @Override
    protected boolean checkExtraStartConditions(class_3218 level, E entity) {
        return entity.method_24828() || entity.method_5799() || entity.method_5771();
    }

    @Override
    protected void start(class_3218 level, E entity, long time) {
        if (entity.method_24828()) {
            entity.method_18380(Poses.DIGGING.get());
            entity.method_5783(WBSoundEvents.WARDEN_DIG, 5.0F, 1.0F);
        } else {
            entity.method_5783(WBSoundEvents.WARDEN_AGITATED, 5.0F, 1.0F);
            this.stop(level, entity, time);
        }
    }

    @Override
    protected void stop(class_3218 level, E entity, long time) {
        if (entity.method_35049() == null) {
            entity.method_5650(class_1297.class_5529.field_26999);
        }
    }
}