package com.cursedcauldron.wildbackport.common.registry;

import java.util.function.Supplier;
import net.minecraft.class_2378;
import net.minecraft.class_2591;
import com.cursedcauldron.wildbackport.WildBackport;
import com.cursedcauldron.wildbackport.common.blocks.entity.MangroveSignBlockEntity;
import com.cursedcauldron.wildbackport.common.blocks.entity.SculkCatalystBlockEntity;
import com.cursedcauldron.wildbackport.common.blocks.entity.SculkShriekerBlockEntity;
import com.cursedcauldron.wildbackport.core.api.CoreRegistry;

//<>

public class WBBlockEntities {
    public static final CoreRegistry<class_2591<?>> BLOCKS
        = CoreRegistry.create(class_2378.field_11137, "minecraft");

    public static final Supplier<class_2591<SculkCatalystBlockEntity>> SCULK_CATALYST
        = BLOCKS.register(
            "sculk_catalyst",
            ()
                -> class_2591.class_2592
                       .method_20528(SculkCatalystBlockEntity::new, WBBlocks.SCULK_CATALYST.get())
                       .method_11034(null)
        );
    public static final Supplier<class_2591<SculkShriekerBlockEntity>> SCULK_SHRIEKER
        = BLOCKS.register(
            "sculk_shrieker",
            ()
                -> class_2591.class_2592
                       .method_20528(SculkShriekerBlockEntity::new, WBBlocks.SCULK_SHRIEKER.get())
                       .method_11034(null)
        );
}