package com.cursedcauldron.wildbackport.common.registry;

import java.util.function.Supplier;
import net.minecraft.class_2378;
import net.minecraft.class_5712;
import com.cursedcauldron.wildbackport.WildBackport;
import com.cursedcauldron.wildbackport.core.api.CoreRegistry;

//<>

public class WBGameEvents {
    public static final CoreRegistry<class_5712> EVENTS
        = CoreRegistry.create(class_2378.field_28264, "minecraft");

    public static final Supplier<class_5712> NOTE_BLOCK_PLAY = create("note_block_play");
    public static final Supplier<class_5712> SCULK_SENSOR_TENDRILS_CLICKING
        = create("sculk_sensor_tendrils_clicking");
    public static final Supplier<class_5712> ENTITY_DIE = create("entity_die");
    public static final Supplier<class_5712> SHRIEK = create("shriek", 32);
    public static final Supplier<class_5712> INSTRUMENT_PLAY = create("instrument_play");

    private static Supplier<class_5712> create(String key) {
        return create(key, 16);
    }

    private static Supplier<class_5712> create(String key, int maxDistance) {
        return EVENTS.register(key, () -> new class_5712(key, maxDistance));
    }
}