package com.cursedcauldron.wildbackport.common.registry;

import java.util.function.Supplier;
import net.minecraft.class_1291;
import net.minecraft.class_2378;
import net.minecraft.class_4081;
import com.cursedcauldron.wildbackport.WildBackport;
import com.cursedcauldron.wildbackport.common.effects.EffectFactor;
import com.cursedcauldron.wildbackport.common.effects.FactorCalculationData;
import com.cursedcauldron.wildbackport.core.api.CoreRegistry;
import com.cursedcauldron.wildbackport.core.mixin.access.MobEffectAccessor;

public class WBMobEffects {
    public static final CoreRegistry<class_1291> EFFECTS
        = CoreRegistry.create(class_2378.field_11159, "minecraft");

    public static final Supplier<class_1291> DARKNESS = EFFECTS.register(
        "darkness",
        ()
            -> EffectFactor
                   .of(MobEffectAccessor.createMobEffect(
                       class_4081.field_18272, 2696993
                   ))
                   .setFactorCalculationData(() -> new FactorCalculationData(22))
    );
}