package com.cursedcauldron.wildbackport.common.registry.entity;

import java.util.function.Supplier;
import net.minecraft.class_1297;
import net.minecraft.class_1299;
import net.minecraft.class_1311;
import net.minecraft.class_2378;
import com.cursedcauldron.wildbackport.WildBackport;
import com.cursedcauldron.wildbackport.common.entities.Allay;
import com.cursedcauldron.wildbackport.common.entities.ChestBoat;
import com.cursedcauldron.wildbackport.common.entities.Frog;
import com.cursedcauldron.wildbackport.common.entities.MangroveBoat;
import com.cursedcauldron.wildbackport.common.entities.Tadpole;
import com.cursedcauldron.wildbackport.common.entities.Warden;
import com.cursedcauldron.wildbackport.core.api.CoreRegistry;

//<>

public class WBEntityTypes {
    public static final CoreRegistry<class_1299<?>> ENTITIES
        = CoreRegistry.create(class_2378.field_11145, "minecraft");

    public static final Supplier<class_1299<Allay>> ALLAY = create(
        "allay",
        class_1299.class_1300.method_5903(Allay::new, class_1311.field_6294)
            .method_17687(0.35F, 0.6F)
            .method_27299(8)
            .method_27300(2)
    );
    public static final Supplier<class_1299<Frog>> FROG = create(
        "frog",
        class_1299.class_1300.method_5903(Frog::new, class_1311.field_6294)
            .method_17687(0.5F, 0.5F)
            .method_27299(10)
    );
    public static final Supplier<class_1299<Tadpole>> TADPOLE = create(
        "tadpole",
        class_1299.class_1300.method_5903(Tadpole::new, class_1311.field_6294)
            .method_17687(0.4F, 0.3F)
            .method_27299(10)
    );
    public static final Supplier<class_1299<Warden>> WARDEN = create(
        "warden",
        class_1299.class_1300.method_5903(Warden::new, class_1311.field_6302)
            .method_17687(0.9F, 2.9F)
            .method_27299(16)
            .method_19947()
    );
    public static final Supplier<class_1299<MangroveBoat>> MANGROVE_BOAT = create(
        "mangrove_boat",
        class_1299.class_1300.<MangroveBoat>method_5903(MangroveBoat::new, class_1311.field_17715)
            .method_17687(1.375F, 0.5625F)
            .method_27299(10)
    );
    public static final Supplier<class_1299<ChestBoat>> CHEST_BOAT = create(
        "chest_boat",
        class_1299.class_1300.<ChestBoat>method_5903(ChestBoat::new, class_1311.field_17715)
            .method_17687(1.375F, 0.5625F)
            .method_27299(10)
    );

    private static <T extends class_1297> Supplier<class_1299<T>>
    create(String key, class_1299.class_1300<T> builder) {
        return ENTITIES.register(key, () -> builder.method_5905(key));
    }
}