package com.cursedcauldron.wildbackport.common.registry.worldgen;

import java.util.function.Supplier;
import net.minecraft.class_2378;
import net.minecraft.class_3031;
import net.minecraft.class_5780;
import com.cursedcauldron.wildbackport.common.worldgen.features.GrassDiskConfiguration;
import com.cursedcauldron.wildbackport.common.worldgen.features.GrassDiskFeature;
import com.cursedcauldron.wildbackport.common.worldgen.features.RootedTreeConfig;
import com.cursedcauldron.wildbackport.common.worldgen.features.RootedTreeFeature;
import com.cursedcauldron.wildbackport.common.worldgen.features.SculkGrowthFeature;
import com.cursedcauldron.wildbackport.common.worldgen.features.SculkPatchConfiguration;
import com.cursedcauldron.wildbackport.common.worldgen.features.SculkPatchFeature;
import com.cursedcauldron.wildbackport.core.api.CoreRegistry;

//<>

public class WBFeatures {
    public static final CoreRegistry<class_3031<?>> FEATURES
        = CoreRegistry.create(class_2378.field_11138, "minecraft");

    public static final Supplier<class_3031<RootedTreeConfig>> TREE = FEATURES.register(
        "rooted_tree", () -> new RootedTreeFeature(RootedTreeConfig.field_24921)
    );
    public static final Supplier<class_3031<GrassDiskConfiguration>> DISK
        = FEATURES.register(
            "grass_disk", () -> new GrassDiskFeature(GrassDiskConfiguration.CODEC)
        );
    public static final Supplier<class_3031<SculkPatchConfiguration>> SCULK_PATCH
        = FEATURES.register(
            "sculk_patch", () -> new SculkPatchFeature(SculkPatchConfiguration.CODEC)
        );
    public static final Supplier<class_3031<class_5780>> SCULK_GROWTH
        = FEATURES.register(
            "sculk_growth", () -> new SculkGrowthFeature(class_5780.field_28429)
        );
}
