package com.cursedcauldron.wildbackport.common.registry.worldgen;

import java.util.function.Supplier;
import net.minecraft.class_2378;
import net.minecraft.class_5142;
import com.cursedcauldron.wildbackport.common.worldgen.placers.UpwardBranchingTrunk;
import com.cursedcauldron.wildbackport.core.api.CoreRegistry;
import com.cursedcauldron.wildbackport.core.mixin.access.TrunkPlacerTypeAccessor;

//<>

public class WBTrunkPlacers {
    public static final CoreRegistry<class_5142<?>> PLACERS
        = CoreRegistry.create(class_2378.field_23782, "minecraft");

    public static final Supplier<class_5142<UpwardBranchingTrunk>>
        UPWARDS_BRANCHING_TRUNK = PLACERS.register(
            "upward_branching_trunk",
            (
            ) -> TrunkPlacerTypeAccessor.createTrunkPlacerType(UpwardBranchingTrunk.field_24972)
        );
}
