package com.cursedcauldron.wildbackport.common.utils;

import java.util.List;
import net.minecraft.class_156;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2382;
import net.minecraft.class_243;
import com.mojang.serialization.Codec;

public class PositionUtils {
    public static final Codec<class_243> VEC_CODEC = Codec.DOUBLE.listOf().comapFlatMap(
        values
        -> {
            return class_156.method_33141(values, 3).map(pos -> {
                return new class_243(pos.get(0), pos.get(1), pos.get(2));
            });
        },
        pos -> { return List.of(pos.method_10216(), pos.method_10214(), pos.method_10215()); }
    );

    public static class_2338 toBlockPos(class_243 pos) {
        return new class_2338(pos.field_1352, pos.field_1351, pos.field_1350);
    }

    public static class_243 toVec(class_2338 pos) {
        return new class_243(pos.method_10263(), pos.method_10264(), pos.method_10260());
    }

    public static class_243 relative(class_243 pos, class_2350 direction, double offset) {
        class_2382 normal = direction.method_10163();
        return new class_243(
            pos.field_1352 + offset * (double) normal.method_10263(),
            pos.field_1351 + offset * (double) normal.method_10264(),
            pos.field_1350 + offset * (double) normal.method_10260()
        );
    }
}