package com.cursedcauldron.wildbackport.common.worldgen;

import com.cursedcauldron.wildbackport.common.registry.WBBiomes;
import com.cursedcauldron.wildbackport.common.registry.WBBlocks;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_5843;
import net.minecraft.class_6686;
import net.minecraft.class_6731;

public class MangroveSwampSurface {
    public static final class_6686.class_6693 ABOVE_60
        = class_6686.method_39051(class_5843.method_33841(60), 0);
    public static final class_6686.class_6693 ABOVE_63
        = class_6686.method_39051(class_5843.method_33841(63), 0);

    public static class_6686.class_6708 makeRules() {
        class_6686.class_6708 terrain = class_6686.method_39050(class_6686.method_39049(
            class_6686.method_39055(WBBiomes.MANGROVE_SWAMP),
            makeStateRule(WBBlocks.MUD.get())
        ));
        class_6686.class_6708 generation = class_6686.method_39050(
            class_6686.method_39049(
                class_6686.field_35222,
                class_6686.method_39050(class_6686.method_39049(
                    class_6686.method_39055(WBBiomes.MANGROVE_SWAMP),
                    class_6686.method_39049(
                        ABOVE_60,
                        class_6686.method_39049(
                            class_6686.method_39048(ABOVE_63),
                            class_6686.method_39049(
                                class_6686.method_39052(class_6731.field_35376, 0.0F),
                                makeStateRule(class_2246.field_10382)
                            )
                        )
                    )
                ))
            ),
            class_6686.method_39049(
                class_6686.field_35222,
                class_6686.method_39049(
                    class_6686.method_39046(-1, 0), class_6686.method_39050(terrain)
                )
            ),
            class_6686.method_39049(
                class_6686.method_39057(-6, -1),
                class_6686.method_39050(
                    class_6686.method_39049(class_6686.field_35223, terrain)
                )
            )
        );
        return class_6686.method_39050(
            class_6686.method_39049(class_6686.method_39473(), generation)
        );
    }

    private static class_6686.class_6708 makeStateRule(class_2248 block) {
        return class_6686.method_39047(block.method_9564());
    }
}