package com.cursedcauldron.wildbackport.core.api.worldgen;

import java.util.function.Consumer;
import net.minecraft.class_1299;
import net.minecraft.class_1311;
import net.minecraft.class_1959;
import net.minecraft.class_2378;
import net.minecraft.class_2893;
import net.minecraft.class_2960;
import net.minecraft.class_5321;
import net.minecraft.class_6796;
import net.minecraft.class_6880;

//<>

public abstract class BiomeWriter {
    @SafeVarargs
    public final void add(Consumer<BiomeWriter> writer, class_5321<class_1959>... biomes) {
        for (class_5321<class_1959> biome : biomes)
            if (this.is(biome))
                writer.accept(this);
    }

    public final void
    add(Consumer<BiomeWriter> writer, class_1959.class_1961... categories) {
        for (class_1959.class_1961 category : categories)
            if (this.is(category))
                writer.accept(this);
    }

    public boolean is(class_5321<class_1959> biome) {
        return biome == class_5321.method_29179(class_2378.field_25114, this.name());
    }

    public boolean is(class_1959.class_1961 category) {
        return category == this.category();
    }

    public abstract class_2960 name();

    public abstract class_1959.class_1961 category();

    public abstract void
    addFeature(class_2893.class_2895 step, class_6880<class_6796> feature);

    public abstract void addSpawn(
        class_1311 category,
        class_1299<?> entityType,
        int weight,
        int minGroupSize,
        int maxGroupSize
    );
}