package com.cursedcauldron.wildbackport.core.mixin.common;

import com.cursedcauldron.wildbackport.common.entities.Allay;
import com.cursedcauldron.wildbackport.core.mixin.access.WalkNodeEvaluatorAccessor;
import net.minecraft.class_14;
import net.minecraft.class_1922;
import net.minecraft.class_2338;
import net.minecraft.class_6;
import net.minecraft.class_7;
import net.minecraft.class_9;
import org.jetbrains.annotations.Nullable;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

//<>

@Mixin(class_6.class)
public abstract class FlyNodeEvaluatorMixin extends class_14 {
    @Shadow
    protected abstract class_7 getCachedBlockPathType(int i, int j, int k);

    @Shadow
    @Nullable
    protected abstract class_9 method_13(int i, int j, int k);

    @Shadow
    public abstract class_7
    method_17(class_1922 blockGetter, int i, int j, int k);

    @Inject(
        method = "getStart",
        at = @At(
            value = "INVOKE",
            target
            = "Lcom/google/common/collect/ImmutableSet;of(Ljava/lang/Object;Ljava/lang/Object;Ljava/lang/Object;Ljava/lang/Object;)Lcom/google/common/collect/ImmutableSet;",
            shift = At.Shift.AFTER
        ),
        cancellable = true
    )
    private void
    wb$start(CallbackInfoReturnable<class_9> cir) {
        if (this.field_33 instanceof Allay allay) {
            for (class_2338 pos : allay.getPotentialEscapePositions()) {
                class_7 types
                    = this.getCachedBlockPathType(pos.method_10263(), pos.method_10264(), pos.method_10260());
                if (this.field_33.method_5944(types) >= 0.0F) {
                    class_9 node = this.method_27137(pos);
                    if (node != null) {
                        node.field_41
                            = ((WalkNodeEvaluatorAccessor) this)
                                  .callGetBlockPathType(this.field_33, node.method_22879());
                        node.field_43 = this.field_33.method_5944(node.field_41);
                    }

                    cir.setReturnValue(node);
                }
            }
        }
    }
}