package com.cursedcauldron.wildbackport.core.mixin.common;

import com.cursedcauldron.wildbackport.common.registry.WBGameEvents;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2428;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_2428.class)
public class NoteBlockMixin {
    @Inject(
        method = "playNote",
        at = @At(
            value = "INVOKE",
            target
            = "Lnet/minecraft/world/level/Level;blockEvent(Lnet/minecraft/core/BlockPos;Lnet/minecraft/world/level/block/Block;II)V",
            shift = At.Shift.AFTER
        )
    )
    private void
    wb$playNote(class_1937 level, class_2338 pos, CallbackInfo ci) {
        level.method_32889(WBGameEvents.NOTE_BLOCK_PLAY.get(), pos);
    }
}