package com.cursedcauldron.wildbackport.core.mixin.common;

import com.cursedcauldron.wildbackport.common.blocks.DrippingFluid;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_3218;
import net.minecraft.class_5689;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_5689.class)
public class PointedDripstoneBlockMixin {
    @Inject(method = "maybeFillCauldron", at = @At("HEAD"), cancellable = true)
    private static void wb$maybeFillCauldron(
        class_2680 state,
        class_3218 level,
        class_2338 pos,
        float dripChance,
        CallbackInfo ci
    ) {
        DrippingFluid.fillCauldron(state, level, pos, ci);
    }
}