package com.cursedcauldron.wildbackport.core.mixin.common;

import java.util.Optional;
import net.minecraft.class_1282;
import net.minecraft.class_1657;
import net.minecraft.class_3222;
import net.minecraft.class_4208;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import com.cursedcauldron.wildbackport.common.entities.access.Recovery;

@Mixin(class_3222.class)
public class ServerPlayerMixin {
    @Inject(method = "die", at = @At("HEAD"))
    private void wb$die(class_1282 ds, CallbackInfo ci) {
        var self = (class_1657) (Object) this;
        Recovery.of(self).setLastDeathLocation(
            Optional.of(class_4208.method_19443(self.field_6002.method_27983(), self.method_24515()))
        );
    }

    @Inject(method = "restoreFrom", at = @At("HEAD"))
    private void wb$restoreFrom(class_3222 sp, boolean bl, CallbackInfo ci) {
        Recovery.of((class_1657) (Object) this)
            .setLastDeathLocation(Recovery.of(sp).getLastDeathLocation());
    }
}
