package com.cursedcauldron.wildbackport.core.mixin.common;

import java.util.Random;
import net.minecraft.class_1299;
import net.minecraft.class_1308;
import net.minecraft.class_1621;
import net.minecraft.class_1936;
import net.minecraft.class_2338;
import net.minecraft.class_3730;
import com.cursedcauldron.wildbackport.common.tag.WBBiomeTags;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(class_1621.class)
public class SlimeMixin {
    @Inject(
        at = @At(
            value = "INVOKE",
            target
            = "Lnet/minecraft/world/level/LevelAccessor;getDifficulty()Lnet/minecraft/world/Difficulty;",
            shift = At.Shift.AFTER
        ),
        method = "checkSlimeSpawnRules",
        cancellable = true
    )
    private static void
    WB$checkSlimeSpawnRules(
        class_1299<class_1621> entity,
        class_1936 level,
        class_3730 spawn,
        class_2338 pos,
        Random random,
        CallbackInfoReturnable<Boolean> cir
    ) {
        if (level.method_23753(pos).method_40220(WBBiomeTags.ALLOWS_SURFACE_SLIME_SPAWNS)
            && pos.method_10264() > 50 && pos.method_10264() < 70 && random.nextFloat() < 0.5F
            && random.nextFloat() < level.method_30272()
            && level.method_22339(pos) <= random.nextInt(8)) {
            cir.setReturnValue(class_1308.method_20636(entity, level, spawn, pos, random));
        }
    }
}