package com.cursedcauldron.wildbackport.client.particle;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2400;
import net.minecraft.class_3999;
import net.minecraft.class_4002;
import net.minecraft.class_4955;
import net.minecraft.class_638;
import net.minecraft.class_703;
import record;

//<>

@Environment(EnvType.CLIENT)
public class SculkSoulParticle extends class_4955 {
    private final class_4002 sprites;

    public SculkSoulParticle(
        class_638 level,
        double x,
        double y,
        double z,
        double xMotion,
        double yMotion,
        double zMotion,
        class_4002 sprites
    ) {
        super(level, x, y, z, xMotion, yMotion, zMotion);
        this.sprites = sprites;
        this.method_18132(1.5F);
        this.method_18142(sprites);
    }

    @Override
    protected int method_3068(float delta) {
        return 240;
    }

    @Override
    public class_3999 method_18122() {
        return class_3999.field_17829;
    }

    @Override
    public void method_3070() {
        super.method_3070();
        this.method_18142(this.sprites);
    }

    @Environment(EnvType.CLIENT)
    public record Provider(class_4002 sprites)
        implements ParticleProvider<SimpleParticleType> {
        @Override
        public class_703 createParticle(
            class_2400 type,
            class_638 level,
            double x,
            double y,
            double z,
            double xMotion,
            double yMotion,
            double zMotion
        ) {
            SculkSoulParticle particle = new SculkSoulParticle(
                level, x, y, z, xMotion, yMotion, zMotion, this.sprites
            );
            particle.method_3083(1.0F);
            return particle;
        }
    }
}