package com.cursedcauldron.wildbackport.client.render.model;

import com.cursedcauldron.wildbackport.common.entities.Tadpole;
import com.google.common.collect.ImmutableList;
import net.minecraft.class_3532;
import net.minecraft.class_4592;
import net.minecraft.class_5603;
import net.minecraft.class_5606;
import net.minecraft.class_5607;
import net.minecraft.class_5609;
import net.minecraft.class_5610;
import net.minecraft.class_630;

public class TadpoleModel<T extends Tadpole> extends class_4592<T> {
    private final class_630 root;
    private final class_630 tail;

    public TadpoleModel(class_630 root) {
        super(true, 8.0F, 3.35F);
        this.root = root;
        this.tail = root.method_32086("tail");
    }

    public static class_5607 createBodyLayer() {
        class_5609 mesh = new class_5609();
        class_5610 root = mesh.method_32111();
        root.method_32117(
            "body",
            class_5606.method_32108().method_32101(0, 0).method_32097(
                -1.5F, -1.0F, 0.0F, 3.0F, 2.0F, 3.0F
            ),
            class_5603.method_32090(0.0F, 22.0F, -3.0F)
        );
        root.method_32117(
            "tail",
            class_5606.method_32108().method_32101(0, 0).method_32097(
                0.0F, -1.0F, 0.0F, 0.0F, 2.0F, 7.0F
            ),
            class_5603.method_32090(0.0F, 22.0F, 0.0F)
        );
        return class_5607.method_32110(mesh, 16, 16);
    }

    @Override
    protected Iterable<class_630> method_22946() {
        return ImmutableList.of(this.root);
    }

    @Override
    protected Iterable<class_630> method_22948() {
        return ImmutableList.of(this.tail);
    }

    @Override
    public void setupAnim(
        T entity,
        float angle,
        float distance,
        float animationProgress,
        float yaw,
        float pitch
    ) {
        float angles = entity.method_5799() ? 1.0F : 1.5F;
        this.tail.field_3675 = -angles * 0.25F * class_3532.method_15374(0.3F * animationProgress);
    }
}