package com.cursedcauldron.wildbackport.common.blocks;

import java.util.Random;
import net.minecraft.class_1799;
import net.minecraft.class_1890;
import net.minecraft.class_1893;
import net.minecraft.class_1937;
import net.minecraft.class_2237;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2464;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_2689;
import net.minecraft.class_2746;
import net.minecraft.class_3218;
import net.minecraft.class_3419;
import net.minecraft.class_5558;
import net.minecraft.class_5714;
import com.cursedcauldron.wildbackport.client.registry.WBParticleTypes;
import com.cursedcauldron.wildbackport.client.registry.WBSoundEvents;
import com.cursedcauldron.wildbackport.common.blocks.entity.SculkCatalystBlockEntity;
import com.cursedcauldron.wildbackport.common.registry.WBBlockEntities;
import org.jetbrains.annotations.Nullable;

//<>

public class SculkCatalystBlock extends class_2237 {
    public static final class_2746 BLOOM = StateProperties.BLOOM;

    public SculkCatalystBlock(class_2251 properties) {
        super(properties);
        this.method_9590(this.field_10647.method_11664().method_11657(BLOOM, false));
    }

    @Override
    protected void
    method_9515(class_2689.class_2690<class_2248, class_2680> builder) {
        builder.method_11667(BLOOM);
    }

    @Override
    public void method_9588(class_2680 state, class_3218 level, class_2338 pos, Random random) {
        if (state.method_11654(BLOOM))
            level.method_8652(pos, state.method_11657(BLOOM, false), 3);
    }

    public static void
    bloom(class_3218 level, class_2338 pos, class_2680 state, Random random) {
        level.method_8652(pos, state.method_11657(BLOOM, true), 3);
        level.method_39279(pos, state.method_26204(), 8);
        level.method_14199(
            WBParticleTypes.SCULK_SOUL.get(),
            (double) pos.method_10263() + 0.5D,
            (double) pos.method_10264() + 1.15D,
            (double) pos.method_10260() + 0.5D,
            2,
            0.2D,
            0.0D,
            0.2D,
            0.0D
        );
        level.method_8396(
            null,
            pos,
            WBSoundEvents.BLOCK_SCULK_CATALYST_BLOOM,
            class_3419.field_15245,
            2.0F,
            0.6F + random.nextFloat() * 0.4F
        );
    }

    @Nullable
    @Override
    public class_2586 method_10123(class_2338 pos, class_2680 state) {
        return new SculkCatalystBlockEntity(pos, state);
    }

    @Nullable
    @Override
    public <T extends class_2586> class_5714 method_32896(class_1937 level, T type) {
        return type instanceof SculkCatalystBlockEntity catalyst ? catalyst : null;
    }

    @Nullable
    @Override
    public <T extends class_2586> class_5558<T>
    method_31645(class_1937 level, class_2680 state, class_2591<T> type) {
        return level.field_9236
            ? null
            : method_31618(
                type, WBBlockEntities.SCULK_CATALYST.get(), SculkCatalystBlockEntity::tick
            );
    }

    @Override
    public class_2464 method_9604(class_2680 state) {
        return class_2464.field_11458;
    }

    @Override
    public void
    method_9565(class_2680 state, class_3218 level, class_2338 pos, class_1799 stack) {
        if (class_1890.method_8225(class_1893.field_9099, stack)
            == 0)
            this.method_9583(level, pos, 5);
    }
}