package com.cursedcauldron.wildbackport.common.entities;

import com.cursedcauldron.wildbackport.common.entities.access.api.BoatTypes;
import com.cursedcauldron.wildbackport.common.registry.WBItems;
import com.cursedcauldron.wildbackport.common.registry.entity.WBEntityTypes;
import net.minecraft.class_1282;
import net.minecraft.class_1299;
import net.minecraft.class_1657;
import net.minecraft.class_1690;
import net.minecraft.class_1792;
import net.minecraft.class_1928;
import net.minecraft.class_1937;
import net.minecraft.class_5712;

//<>

public class MangroveBoat extends class_1690 {
    public MangroveBoat(class_1299<? extends class_1690> type, class_1937 level) {
        super(type, level);
    }

    public MangroveBoat(class_1937 level, double x, double y, double z) {
        super(WBEntityTypes.MANGROVE_BOAT.get(), level);
        this.method_5814(x, y, z);
        this.field_6014 = x;
        this.field_6036 = y;
        this.field_5969 = z;
    }

    @Override
    public boolean method_5643(class_1282 source, float amount) {
        if (this.method_5679(source)) {
            return false;
        } else if (!this.field_6002.method_8608() && !this.method_31481()) {
            this.method_7540(-this.method_7543());
            this.method_7553(10);
            this.method_7542(this.method_7554() + amount * 10.0F);
            this.method_5785();
            this.method_32875(class_5712.field_28736, source.method_5529());
            boolean isCreativePlayer = source.method_5529() instanceof class_1657 player
                && player.method_31549().field_7477;
            if (isCreativePlayer || this.method_7554() > 40.0F) {
                if (!isCreativePlayer
                    && this.field_6002.method_8450().method_8355(class_1928.field_19393))
                    this.dropItems(source);

                this.method_31472();
            }

            return true;
        } else {
            return true;
        }
    }

    protected void dropItems(class_1282 source) {
        this.method_5706(this.method_7557());
    }

    @Override
    public class_1792 method_7557() {
        return this.method_7536() != BoatTypes.MANGROVE.get()
            ? super.method_7557()
            : WBItems.MANGROVE_BOAT.get();
    }
}