package com.cursedcauldron.wildbackport.common.entities.brain;

import com.cursedcauldron.wildbackport.common.entities.Tadpole;
import com.google.common.collect.ImmutableList;
import com.google.common.collect.ImmutableMap;
import com.google.common.collect.ImmutableSet;
import com.mojang.datafixers.util.Pair;
import net.minecraft.class_1297;
import net.minecraft.class_1299;
import net.minecraft.class_1309;
import net.minecraft.class_4095;
import net.minecraft.class_4101;
import net.minecraft.class_4103;
import net.minecraft.class_4110;
import net.minecraft.class_4112;
import net.minecraft.class_4119;
import net.minecraft.class_4120;
import net.minecraft.class_4140;
import net.minecraft.class_4141;
import net.minecraft.class_4168;
import net.minecraft.class_4818;
import net.minecraft.class_4820;
import net.minecraft.class_4821;
import net.minecraft.class_5753;
import net.minecraft.class_5755;
import net.minecraft.class_5756;
import net.minecraft.class_6019;
import net.minecraft.class_6028;

public class TadpoleBrain {
    public static class_4095<?> create(class_4095<Tadpole> brain) {
        TadpoleBrain.addCoreActivities(brain);
        TadpoleBrain.addIdleActivities(brain);
        brain.method_18890(ImmutableSet.of(class_4168.field_18594));
        brain.method_18897(class_4168.field_18595);
        brain.method_24536();
        return brain;
    }

    private static void addCoreActivities(class_4095<Tadpole> brain) {
        brain.method_18882(
            class_4168.field_18594,
            0,
            ImmutableList.of(
                new class_6028(2.0f),
                new class_4110(45, 90),
                new class_4112(),
                new class_5753(class_4140.field_28326)
            )
        );
    }

    private static void addIdleActivities(class_4095<Tadpole> brain) {
        brain.method_18881(
            class_4168.field_18595,
            ImmutableList.of(
                Pair.of(
                    0,
                    new class_4821<class_1309>(
                        new class_4119(class_1299.field_6097, 6.0f),
                        class_6019.method_35017(30, 60)
                    )
                ),
                Pair.of(3, new class_5756(6, 0.15f)),
                Pair.of(
                    4,
                    new class_4103<>(
                        ImmutableMap
                            .of(class_4140.field_18445, class_4141.field_18457),
                        ImmutableSet.of(),
                        class_4103.class_4104.field_18348,
                        class_4103.class_4216.field_18856,
                        ImmutableList.of(
                            Pair.of(new class_5755(0.5F), 2),
                            Pair.of(new class_4818(0.15F), 2),
                            Pair.of(new class_4120(0.5f, 3), 3),
                            Pair
                                .of(new class_4820<>(
                                        class_1297::method_5816, new class_4101(30, 60)
                                    ),
                                    5)
                        )
                    )
                )
            )
        );
    }

    public static void updateActivities(Tadpole tadpole) {
        tadpole.method_18868().method_24531(ImmutableList.of(class_4168.field_18595));
    }
}