package com.cursedcauldron.wildbackport.common.entities.brain.warden;

import java.util.Comparator;
import java.util.List;
import java.util.Set;
import net.minecraft.class_1309;
import net.minecraft.class_238;
import net.minecraft.class_3218;
import net.minecraft.class_4140;
import net.minecraft.class_4148;
import net.minecraft.class_6670;
import com.google.common.collect.ImmutableSet;

//<>

public class NearestLivingEntitySensor<T extends class_1309> extends class_4148<T> {
    @Override
    protected void method_19101(class_3218 level, T entity) {
        class_238 box = entity.method_5829().method_1009(
            this.getHorizontalExpansion(),
            this.getHeightExpansion(),
            this.getHorizontalExpansion()
        );
        List<class_1309> entities = level.method_8390(
            class_1309.class, box, target -> target != entity && target.method_5805()
        );
        entities.sort(Comparator.comparingDouble(entity::method_5858));
        entity.method_18868().method_18878(class_4140.field_18441, entities);
        entity.method_18868().method_18878(
            class_4140.field_18442,
            new class_6670(entity, entities)
        );
    }

    protected int getHorizontalExpansion() {
        return 16;
    }

    protected int getHeightExpansion() {
        return 16;
    }

    @Override
    public Set<class_4140<?>> method_19099() {
        return ImmutableSet.of(
            class_4140.field_18441,
            class_4140.field_18442
        );
    }
}