package com.cursedcauldron.wildbackport.common.entities.brain.warden;

import com.cursedcauldron.wildbackport.common.entities.Warden;
import com.cursedcauldron.wildbackport.common.registry.entity.WBMemoryModules;
import com.google.common.collect.ImmutableMap;
import net.minecraft.class_1297;
import net.minecraft.class_2338;
import net.minecraft.class_3218;
import net.minecraft.class_4097;
import net.minecraft.class_4099;
import net.minecraft.class_4140;
import net.minecraft.class_4141;

//<>

public class SetWardenLookTarget extends class_4097<Warden> {
    public SetWardenLookTarget() {
        super(ImmutableMap.of(
            WBMemoryModules.DISTURBANCE_LOCATION.get(),
            class_4141.field_18458,
            WBMemoryModules.ROAR_TARGET.get(),
            class_4141.field_18458,
            class_4140.field_22355,
            class_4141.field_18457
        ));
    }

    @Override
    protected boolean checkExtraStartConditions(class_3218 level, Warden warden) {
        return warden.method_18868().method_18896(WBMemoryModules.DISTURBANCE_LOCATION.get()
               )
            || warden.method_18868().method_18896(WBMemoryModules.ROAR_TARGET.get());
    }

    @Override
    protected void start(class_3218 level, Warden warden, long time) {
        class_2338 pos = warden.method_18868()
                           .method_18904(WBMemoryModules.ROAR_TARGET.get())
                           .map(class_1297::method_24515)
                           .or(()
                                   -> warden.method_18868().method_18904(
                                       WBMemoryModules.DISTURBANCE_LOCATION.get()
                                   ))
                           .get();
        warden.method_18868().method_18878(
            class_4140.field_18446, new class_4099(pos)
        );
    }
}