package com.cursedcauldron.wildbackport.common.entities.brain.warden;

import java.util.Collection;
import java.util.List;
import java.util.Optional;
import java.util.Set;
import java.util.function.Predicate;
import net.minecraft.class_1299;
import net.minecraft.class_1309;
import net.minecraft.class_3218;
import net.minecraft.class_4140;
import com.cursedcauldron.wildbackport.common.entities.Warden;
import com.google.common.collect.ImmutableSet;
import com.google.common.collect.Iterables;

public class WardenEntitySensor extends NearestLivingEntitySensor<Warden> {
    @Override
    public Set<class_4140<?>> method_19099() {
        return ImmutableSet.copyOf(Iterables.concat(
            super.method_19099(), List.of(class_4140.field_30243)
        ));
    }

    @Override
    protected void doTick(class_3218 level, Warden warden) {
        super.method_19101(level, warden);
        findNearestTarget(warden, target -> target.method_5864() == class_1299.field_6097)
            .or(()
                    -> findNearestTarget(
                        warden, target -> target.method_5864() != class_1299.field_6097
                    ))
            .ifPresentOrElse(
                target
                -> warden.method_18868().method_18878(
                    class_4140.field_30243, target
                ),
                () -> warden.method_18868().method_18875(class_4140.field_30243)
            );
    }

    private static Optional<class_1309>
    findNearestTarget(Warden warden, Predicate<class_1309> targetPredicate) {
        return warden.method_18868()
            .method_18904(class_4140.field_18441)
            .stream()
            .flatMap(Collection::stream)
            .filter(warden::isValidTarget)
            .filter(targetPredicate)
            .findFirst();
    }

    @Override
    protected int getHorizontalExpansion() {
        return 24;
    }

    @Override
    protected int getHeightExpansion() {
        return 24;
    }
}