package com.cursedcauldron.wildbackport.common.registry.worldgen;

import com.cursedcauldron.wildbackport.common.utils.SupplierHolder;
import com.cursedcauldron.wildbackport.common.worldgen.features.AncientCityFeature;
import com.cursedcauldron.wildbackport.core.api.CoreRegistry;
import com.cursedcauldron.wildbackport.core.mixin.access.StructureFeatureAccessor;

import net.anvilcraft.anvillib.worldgen.AdvancedStructurePoolFeatureConfig;
import net.minecraft.class_2378;
import net.minecraft.class_2893.class_2895;
import net.minecraft.class_3195;
import net.minecraft.class_6880;

public class WBStructureFeatures {
    public static final CoreRegistry<class_3195<?>> STRUCTURE_FEATURES
        = CoreRegistry.create(class_2378.field_16644, "minecraft");

    public static final class_6880<class_3195<?>> ANCIENT_CITY
        = SupplierHolder.createAndRegister(STRUCTURE_FEATURES, "ancient_city", () -> {
              var acf = new AncientCityFeature(AdvancedStructurePoolFeatureConfig.CODEC);
              StructureFeatureAccessor.getStep().put(
                  acf, class_2895.field_13172
              );
              return acf;
          });
}
