package com.cursedcauldron.wildbackport.common.registry.worldgen;

import java.util.function.Supplier;
import net.minecraft.class_2378;
import net.minecraft.class_4663;
import com.cursedcauldron.wildbackport.common.worldgen.decorator.AttachedToLeavesDecorator;
import com.cursedcauldron.wildbackport.common.worldgen.decorator.WeightedLeaveVineDecorator;
import com.cursedcauldron.wildbackport.core.api.CoreRegistry;
import com.cursedcauldron.wildbackport.core.mixin.access.TreeDecoratorTypeAccessor;

//<>

public class WBTreeDecorators {
    public static final CoreRegistry<class_4663<?>> DECORATORS
        = CoreRegistry.create(class_2378.field_21448, "minecraft");

    public static final Supplier<class_4663<WeightedLeaveVineDecorator>>
        WEIGHTED_LEAVE_VINE = DECORATORS.register(
            "weighted_leave_vine",
            ()
                -> TreeDecoratorTypeAccessor.createTreeDecoratorType(
                    WeightedLeaveVineDecorator.field_24962
                )
        );
    public static final Supplier<class_4663<AttachedToLeavesDecorator>>
        ATTACHED_TO_LEAVES = DECORATORS.register(
            "attached_to_leaves",
            ()
                -> TreeDecoratorTypeAccessor.createTreeDecoratorType(
                    AttachedToLeavesDecorator.field_24962
                )
        );
}
