package com.cursedcauldron.wildbackport.common.utils;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Random;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import net.minecraft.class_2350;

public class DirectionUtils {
    public static Collection<class_2350> shuffle(Random random) {
        List<class_2350> directions
            = Arrays.stream(class_2350.values()).collect(Collectors.toList());
        Collections.shuffle(directions, random);
        return directions;
    }

    public static Stream<class_2350> stream() {
        return Stream.of(class_2350.values());
    }

    public static Collection<class_2350> unpack(byte faces) {
        ArrayList<class_2350> directions = new ArrayList<>(6);
        for (class_2350 direction : class_2350.values()) {
            if ((faces & (byte) (2 << direction.ordinal() >> 1)) > 0) {
                directions.add(direction);
            }
        }

        return directions;
    }
}