package com.cursedcauldron.wildbackport.common.utils;

import java.util.List;
import net.minecraft.class_1291;
import net.minecraft.class_1293;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1542;
import net.minecraft.class_1799;
import net.minecraft.class_243;
import net.minecraft.class_3218;
import net.minecraft.class_3222;
import net.minecraft.class_4115;
import net.minecraft.class_4140;
import net.minecraft.class_4142;
import org.jetbrains.annotations.Nullable;

public class MobUtils {
    public static void addEffectToPlayersWithinDistance(
        class_3218 level,
        @Nullable class_1297 entity,
        class_243 position,
        double distance,
        class_1293 instance,
        int duration
    ) {
        class_1291 mobeffect = instance.method_5579();
        List<class_3222> players = level.method_18766(
            player
            -> player.field_13974.method_14267()
                && (entity == null || !entity.method_5722(player))
                && position.method_24802(player.method_19538(), distance)
                && (!player.method_6059(mobeffect)
                    || player.method_6112(mobeffect).method_5578()
                        < instance.method_5578()
                    || player.method_6112(mobeffect).method_5584() < duration)
        );
        players.forEach(
            player -> player.method_37222(new class_1293(instance), entity)
        );
    }

    public static void walkTowards(
        class_1309 entity, class_4115 target, float speed, int closeEnough
    ) {
        class_4142 walkTarget = new class_4142(target, speed, closeEnough);
        entity.method_18868().method_18878(class_4140.field_18446, target);
        entity.method_18868().method_18878(class_4140.field_18445, walkTarget);
    }

    public static void give(
        class_1309 entity, class_1799 stack, class_243 target, class_243 velocity, float yOffset
    ) {
        double y = entity.method_23320() - (double) yOffset;
        class_1542 item
            = new class_1542(entity.field_6002, entity.method_23317(), y, entity.method_23321(), stack);
        item.method_6981(entity.method_5667());
        class_243 distance = target.method_1020(entity.method_19538());
        distance = distance.method_1029().method_18805(velocity.field_1352, velocity.field_1351, velocity.field_1350);
        item.method_18799(distance);
        item.method_6988();
        entity.field_6002.method_8649(item);
    }
}