package com.cursedcauldron.wildbackport.common.utils;

import java.util.Optional;
import net.minecraft.class_2540;
import net.minecraft.class_2941;

public class OptionalEntityDataSerializer<T>
    implements class_2941<Optional<T>> {
    final class_2941<T> inner;

    public OptionalEntityDataSerializer(class_2941<T> inner) {
        this.inner = inner;
    }

    @Override
    public Optional<T> copy(Optional<T> object) {
        return object.map(this.inner::method_12714);
    }

    @Override
    public Optional<T> method_12716(class_2540 fbb) {
        return fbb.readBoolean() ? Optional.of(this.inner.method_12716(fbb)) : Optional.empty();
    }

    @Override
    public void write(class_2540 fbb, Optional<T> object) {
        fbb.writeBoolean(object.isPresent());
        object.ifPresent(innerObj -> this.inner.method_12715(fbb, innerObj));
    }
}
