package com.cursedcauldron.wildbackport.common.worldgen.structure;

import com.cursedcauldron.wildbackport.common.worldgen.structure.pools.AncientCityStructurePools;
import com.cursedcauldron.wildbackport.common.worldgen.structure.processors.WBProcessorLists;
import com.google.common.collect.ImmutableList;
import com.mojang.datafixers.util.Pair;
import net.minecraft.class_2960;
import net.minecraft.class_3784;
import net.minecraft.class_3785;
import net.minecraft.class_5468;
import net.minecraft.class_6880;

public class AncientCityStructurePieces {
    public static final class_6880<class_3785> START
        = class_5468.method_30600(new class_3785(
            new class_2960("ancient_city/city_center"),
            new class_2960("empty"),
            ImmutableList.of(
                Pair.of(
                    class_3784.method_30435(
                        "ancient_city/city_center/city_center_1",
                        WBProcessorLists.ANCIENT_CITY_START_DEGRADATION
                    ),
                    1
                ),
                Pair.of(
                    class_3784.method_30435(
                        "ancient_city/city_center/city_center_2",
                        WBProcessorLists.ANCIENT_CITY_START_DEGRADATION
                    ),
                    1
                ),
                Pair.of(
                    class_3784.method_30435(
                        "ancient_city/city_center/city_center_3",
                        WBProcessorLists.ANCIENT_CITY_START_DEGRADATION
                    ),
                    1
                )
            ),
            class_3785.class_3786.field_16687
        ));

    public static void bootstrap() {
        AncientCityStructurePools.bootstrap();
    }
}
