package com.cursedcauldron.wildbackport.common.worldgen.structure;

import java.util.List;
import net.minecraft.class_2960;
import net.minecraft.class_3784;
import net.minecraft.class_3785;
import net.minecraft.class_3791;
import net.minecraft.class_5458;
import net.minecraft.class_5469;
import com.cursedcauldron.wildbackport.core.mixin.access.StructureTemplatePoolAccessor;
import com.mojang.datafixers.util.Pair;

//<>

public class StructureGeneration {
    public static void registerAllayCages() {
        class_3791.method_27235();
        StructureGeneration.addToPool(
            new class_2960("pillager_outpost/features"),
            new class_2960("pillager_outpost/feature_cage_with_allays"),
            1
        );
    }

    private static void
    addToPool(class_2960 poolId, class_2960 pieceId, int weight) {
        class_3785 pool = class_5458.field_25932.method_10223(poolId);
        if (pool == null)
            return;

        class_3784 piece
            = class_3784.method_30426(pieceId.toString(), class_5469.field_26688)
                  .apply(class_3785.class_3786.field_16687);
        List<class_3784> templates
            = ((StructureTemplatePoolAccessor) pool).getTemplates();
        List<Pair<class_3784, Integer>> rawTemplates
            = ((StructureTemplatePoolAccessor) pool).getRawTemplates();
        if (templates == null || rawTemplates == null)
            return;

        for (int i = 0; i < weight; i++)
            templates.add(piece);
        rawTemplates.add(Pair.of(piece, weight));
    }
}
