package com.cursedcauldron.wildbackport.common.worldgen.structure.processors;

import com.cursedcauldron.wildbackport.common.tag.WBBlockTags;
import com.google.common.collect.ImmutableList;
import net.minecraft.class_2246;
import net.minecraft.class_2960;
import net.minecraft.class_3481;
import net.minecraft.class_3491;
import net.minecraft.class_3818;
import net.minecraft.class_3821;
import net.minecraft.class_3824;
import net.minecraft.class_3826;
import net.minecraft.class_5458;
import net.minecraft.class_5497;
import net.minecraft.class_6378;
import net.minecraft.class_6880;

public class WBProcessorLists {
    public static final class_6880<class_5497> ANCIENT_CITY_START_DEGRADATION
        = create(
            "ancient_city_start_degradation",
            ImmutableList.of(
                new class_3826(ImmutableList.of(
                    new class_3821(
                        new class_3824(class_2246.field_28900, 0.3F),
                        class_3818.field_16868,
                        class_2246.field_29222.method_9564()
                    ),
                    new class_3821(
                        new class_3824(class_2246.field_28896, 0.3F),
                        class_3818.field_16868,
                        class_2246.field_29223.method_9564()
                    ),
                    new class_3821(
                        new class_3824(class_2246.field_22110, 0.05F),
                        class_3818.field_16868,
                        class_2246.field_10124.method_9564()
                    )
                )),
                new class_6378(class_3481.field_33757)
            )
        );
    public static final class_6880<class_5497> ANCIENT_CITY_GENERIC_DEGRADATION
        = create(
            "ancient_city_generic_degradation",
            ImmutableList.of(
                new BlockTagRotProcessor(WBBlockTags.ANCIENT_CITY_REPLACEABLE, 0.95F),
                new class_3826(ImmutableList.of(
                    new class_3821(
                        new class_3824(class_2246.field_28900, 0.3F),
                        class_3818.field_16868,
                        class_2246.field_29222.method_9564()
                    ),
                    new class_3821(
                        new class_3824(class_2246.field_28896, 0.3F),
                        class_3818.field_16868,
                        class_2246.field_29223.method_9564()
                    ),
                    new class_3821(
                        new class_3824(class_2246.field_22110, 0.05F),
                        class_3818.field_16868,
                        class_2246.field_10124.method_9564()
                    )
                )),
                new class_6378(class_3481.field_33757)
            )
        );
    public static final class_6880<class_5497> ANCIENT_CITY_WALLS_DEGRADATION
        = create(
            "ancient_city_walls_degradation",
            ImmutableList.of(
                new BlockTagRotProcessor(WBBlockTags.ANCIENT_CITY_REPLACEABLE, 0.95F),
                new class_3826(ImmutableList.of(
                    new class_3821(
                        new class_3824(class_2246.field_28900, 0.3F),
                        class_3818.field_16868,
                        class_2246.field_29222.method_9564()
                    ),
                    new class_3821(
                        new class_3824(class_2246.field_28896, 0.3F),
                        class_3818.field_16868,
                        class_2246.field_29223.method_9564()
                    ),
                    new class_3821(
                        new class_3824(class_2246.field_28898, 0.3F),
                        class_3818.field_16868,
                        class_2246.field_10124.method_9564()
                    ),
                    new class_3821(
                        new class_3824(class_2246.field_22110, 0.05F),
                        class_3818.field_16868,
                        class_2246.field_10124.method_9564()
                    )
                )),
                new class_6378(class_3481.field_33757)
            )
        );

    public static void bootstrap() {}

    private static class_6880<class_5497>
    create(String key, ImmutableList<class_3491> processors) {
        return class_5458.method_30562(
            class_5458.field_25931,
            new class_2960(key),
            new class_5497(processors)
        );
    }
}
