package com.cursedcauldron.wildbackport.core.api;

import SampleRegistry;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import net.minecraft.class_5321;

public class RegistryBuilder {
    private final String modId;

    public RegistryBuilder(String modId) {
        this.modId = modId;
    }

    public static RegistryBuilder create(String modId) {
        return new RegistryBuilder(modId);
    }

    public <T> SampleRegistry<T>
    create(String key, class_2378.class_6889<T> bootstrap) {
        class_5321<class_2378<T>> resource
            = class_5321.method_29180(new class_2960(this.modId, key));
        return new SampleRegistry<>(
            resource, class_2378.method_10247(resource, bootstrap)
        );
    }
}