package com.cursedcauldron.wildbackport.core.mixin.common;

import com.cursedcauldron.wildbackport.common.entities.access.Vibration;
import com.cursedcauldron.wildbackport.common.registry.WBGameEvents;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_5703;
import net.minecraft.class_5704;
import net.minecraft.class_5712;
import net.minecraft.class_5714;
import net.minecraft.class_5718;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_5704.class)
public class SculkSensorBlockEntityMixin extends class_2586 {
    @Shadow
    @Final
    private class_5718 listener;

    public SculkSensorBlockEntityMixin(
        class_2591<?> type, class_2338 pos, class_2680 state
    ) {
        super(type, pos, state);
    }

    @Inject(method = "onSignalReceive", at = @At("HEAD"))
    private void receiveSignal(
        class_1937 level,
        class_5714 listener,
        class_5712 event,
        int delay,
        CallbackInfo ci
    ) {
        if (!level.method_8608() && class_5703.method_32909(this.method_11010())) {
            Vibration.Instance instance = Vibration.Instance.of(this.listener);
            level.method_32888(
                instance.getEntity(),
                WBGameEvents.SCULK_SENSOR_TENDRILS_CLICKING.get(),
                instance.getPos()
            );
        }
    }
}