package com.cursedcauldron.wildbackport.core.mixin.network;

import com.cursedcauldron.wildbackport.common.entities.ChestBoat;
import net.minecraft.class_310;
import net.minecraft.class_636;
import net.minecraft.class_746;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(class_636.class)
public class MultiPlayerGameModeMixin {
    @Shadow
    @Final
    private class_310 minecraft;

    @Inject(method = "isServerControlledInventory", at = @At("TAIL"), cancellable = true)
    private void wb$handleInventory(CallbackInfoReturnable<Boolean> cir) {
        class_746 player = this.minecraft.field_1724;
        cir.setReturnValue(
            player != null && player.method_5765()
                && player.method_5854() instanceof ChestBoat
            || cir.getReturnValue()
        );
    }
}